<?php

##########################################################################################
# In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
#
# AUSTRALIA - http://shopmania.com.au/ (only supporting AUD, NZD datafeeds)
# ARGENTINA - http://www.shopmania.com.ar/ (only supporting ARS, EUR, USD)       *NEW
# BRASIL - http://www.shopmania.com.br/ (only supporting BRL, USD) 
# BULGARY - http://www.shopmania.bg/ (only supporting BGN, EUR, USD)
# CZECH REPUBLIC - http://www.shop-mania.cz/ (only supporting CZK, EUR, USD)		*NEW
# CHILE - http://www.shopmania.cl/ (only supporting CLP, USD, EUR)       *NEW
# CHINA - http://www.shopmania.cn/ (only supporting CNY, USD)       
# DEUTSCHLAND - http://www.shopmania.de/ (only supporting EUR, USD) 
# FRANCE - http://www.shopmania.fr/ (only supporting EUR, USD datafeeds)
# HUNGARY - http://www.shopmania.hu/ (only supporting HUF, EUR, USD datafeeds)
# INDIA - http://www.shopmania.in/ (only supporting INR, USD datafeeds)
# IRELAND - http://www.shopmania.ie/ (only supporting EUR, GBP datafeeds)
# ITALY - http://www.shopmania.it/ (only supporting EUR, USD datafeeds)
# JAPAN - http://www.shopmania.jp/  (only supporting JPY, USD datafeeds)       
# MEXICO - http://www.shopmania.com.mx/ (only supporting MXN (Mexican peso), USD, EUR datafeeds)
# NETHERLANDS - http://www.shopmania.nl/ (only supporting EUR datafeeds)		*NEW
# POLSKA - http://www.shopmania.pl/ (only supporting PLN, EUR, USD) 
# PORTUGAL - http://www.shopmania.pt/ (only supporting EUR, USD) 
# ROMANIA - http://www.shopmania.ro/ (only supporting RON, EUR, USD datafeeds)
# RUSSIA - http://www.shopmania.ru/ (only supporting RUB, EUR, USD)       
# SERBIA - http://www.shopmania.rs/ (only supporting RSD, EUR)		*NEW	
# SLOVAKIA - http://www.shop-mania.sk/ (only supporting EUR, USD)
# SOUTH AFRICA - http://www.shopmania.co.za/ (only supporting ZAR, USD, EUR)       *NEW
# SPAIN - http://www.shopmania.es/ (only supporting EUR datafeeds) 
# SWEDEN - http://www.shopmania.se/ (only supporting SEK, EUR, USD datafeeds)		*NEW
# TURKEY - http://www.shopmania.com.tr/ (only supporting TRY, EUR, USD)
# US - http://www.shopmania.com/ (only supporting USD, CAD datafeeds)
# UK - http://www.shopmania.co.uk/ (only supporting GBP, EUR, USD datafeeds)
#
# Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
# Files will be  retrieved daily from your server having the products listed automatically on ShopMania
#
# phpshop price options - taxes = on,off (default = on); storetaxes = on,off (default = on); discount = on,off (default = on)
# datafeed_shopmania_phpshop.php?storetaxes=off
# datafeed_shopmania_phpshop.php?taxes=off
# datafeed_shopmania_phpshop.php?discount=off
# datafeed_shopmania_phpshop.php?taxes=off&storetaxes=off&discount=off
# datafeed_shopmania_phpshop.php?add_vat=on
#
# General options
# description = on,off
# image = on,off
# 
##########################################################################################

// Current datafeed script version
$script_version = "1.05";

// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed PhpShop</b><br />";
	echo "script version <b>" . $script_version . "</b><br />";
	exit;
}

if (!ini_get("safe_mode")) {
    set_time_limit(0);
}
ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);
$_SVR = array();

##### Include configuration files ################################################

# You need to do place this file in your root directory, where the configuration file is located.
# Otherwise, if you place this file in another directory please modify the line below with the path to the directory where the configuration file is located.
# In this case, $site_base_path should contain the path that is found in $mosConfig_absolute_path variable from the configuration.php file, followed by / 

$site_base_path = "./";

# Once all is set up you need to check the result and make sure the output is correct
# Point the browser to http://www.example.com/path_to_datafeed/shopmania_datafeed.php and look into the source code of the out put
# What you need to see is something like this
# Category | Manufacturer | Part Number | Merchant Code | Product Name | Product Description | Product URL | Product Image URL | Product Price | Currency 

##### Avoid any modifications below this line #####

// Include configuration file
if(!file_exists($site_base_path . "configuration.php")) {
	exit('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Please ensure that datafeed_shopmania_phpshop.php is in the root directory, or make sure the path to the directory where the configuration file is located is defined corectly above in $site_base_path variable</BODY></HTML>');
}
else {
	require_once($site_base_path . "configuration.php");
}

####################################################################


##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$tagging_params = (@$_GET['tagging_params'] != "") ? urldecode($_GET['tagging_params']) : "utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link";
$show_description = (@$_GET['description'] == "off") ? "off" : "on";
$show_image = (@$_GET['image'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock'] == "on") ? "on" : "off";
$currency = (@$_GET['currency'] != "") ? $_GET['currency'] : "";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$force_folder = (@$_GET['forcefolder'] != "") ? $_GET['forcefolder'] : "";

####################################################################

$already_sent = array();

// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |

// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	
	echo "<b>Datafeed PhpShop</b><br />";
	echo "script version <b>" . $script_version . "</b><br /><br /><br />";
		
	echo "<b>Taxes options</b> - possible values on, off default value on<br />";
	echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	echo "<b>Store taxes options</b> - possible values on, off default value on<br />";
	echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	echo "<b>Discount options</b> - possible values on, off default value on<br />";
	echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	
	echo "<b>Add VAT to prices</b> - possible values on, off default value off<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
	
	echo "<b>VAT value</b> - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";
	
	//echo "Add shipping to datafeed - possible values on, off default value off<br />";
	//echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=off" . "\" >" . $script_basepath . "?shipping=off" . "</a><br /><br />";
	
	echo "<b>Add GA Tagging to product URL</b> - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
	
	echo "<b>Tagging to product URL</b> - possible values url_encode(TAGGING_PARAMS) default value tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=from%3Dshopmania" . "\" >" . $script_basepath . "?tagging_params=from%3Dshopmania" . "</a><br /><br />";
	
	echo "<b>Display Description options</b> - possible values on, off<br />";
	echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br /><br />";

	echo "<b>Display image options</b> - possible values on, off default value on<br />";
	echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	//echo "Special price options - possible values on, off default value on<br />";
	//echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	//echo "<b>Show only on stock products</b> - possible values on, off default value off<br />";
	//echo "on_stock=off (on,off) <a href=\"" . $script_basepath . "?on_stock=on" . "\" >" . $script_basepath . "?on_stock=on" . "</a><br /><br />";
	
	//echo "<b>Show SEO friendly url</b> - possible values on, off default value off<br />";
	//echo "sef=off (on,off) <a href=\"" . $script_basepath . "?sef=on" . "\" >" . $script_basepath . "?sef=on" . "</a><br /><br />";
	
	//echo "<b>Get prices in specified currency</b> - possible values USD,EUR etc. <br />";
	//echo "currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?currency=EUR" . "\" >" . $script_basepath . "?currency=EUR" . "</a><br /><br />";
	
	//echo "Get texts in specified language code - possible values en,ro etc. <br />";
	//echo "language=DEFAULT_LANGUAGE_CODE <a href=\"" . $script_basepath . "?language=en" . "\" >" . $script_basepath . "?language=en" . "</a><br /><br />";
	
	//echo "Get texts in specified language id - possible values 1,2 etc. <br />";
	//echo "language_id=DEFAULT_LANGUAGE_ID <a href=\"" . $script_basepath . "?language_id=1" . "\" >" . $script_basepath . "?language_id=1" . "</a><br /><br />";
	
	echo "<br />";
	
	exit;
	
}


##### Connect to database ################################################

$conn = @mysql_connect($mosConfig_host, $mosConfig_user, $mosConfig_password);
if (mysql_error()) {
	print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Connection error. Please check the connection settings. Bye bye...</BODY></HTML>";
	exit;
}
else {
	@mysql_select_db($mosConfig_db, $conn);
	if (mysql_error()) {
		print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Connection error. Please check the connection settings. Bye bye...</BODY></HTML>";
		exit;
	}
}

####################################################################


##### Extract options from database ################################################

// Tables variables
$prod_table = $mosConfig_dbprefix . "pshop_product"; // products table
$cat_table = $mosConfig_dbprefix . "pshop_category"; // categories table
$cat_xref_table = $mosConfig_dbprefix . "pshop_category_xref"; // categories xref table
$manuf_table = $mosConfig_dbprefix . "pshop_manufacturer"; // manufacturer table
$price_table = $mosConfig_dbprefix . "pshop_product_price"; // product price table
$manuf_xref_table = $mosConfig_dbprefix . "pshop_product_mf_xref"; // product manufacturer xref table
$prod_cat_xref_table = $mosConfig_dbprefix . "pshop_product_category_xref"; // product category xref table
$tax_rate_table = $mosConfig_dbprefix . "pshop_tax_rate"; // tax rate table
$vendor_table = $mosConfig_dbprefix . "pshop_vendor"; // vendor table
$discount_table = $mosConfig_dbprefix . "pshop_product_discount"; // vendor table

// Get the store's tax rate
$q = "SELECT tax_rate FROM $vendor_table, $tax_rate_table WHERE tax_country=vendor_country AND $vendor_table.vendor_id='1' ORDER BY tax_rate DESC LIMIT 0,1";
$r = @mysql_query($q);
if (!mysql_error()) {
	while ($field = mysql_fetch_assoc($r)) {
		$rate = $field['tax_rate'];
	}
}

// Get all categories
$res_cat = @mysql_query("SELECT $cat_table.category_id, $cat_table.category_name, $cat_xref_table.category_parent_id as parent_id, $cat_table.category_flypage
FROM $cat_table
LEFT JOIN $cat_xref_table ON ( $cat_table.category_id = $cat_xref_table.category_child_id )");
if (!mysql_error()) {
	while ($field = mysql_fetch_assoc($res_cat)) {
		$CAT_ARR[$field['category_id']] = $field;
	}
}

####################################################################


##### Extract products from database ###############################################

// Query database for extracting data. It might be needed to left join the categories table for extracting the category name
$image_field = ($show_image == "on") ? "$prod_table.product_full_image" : "''";
$description_field = ($show_description == "on") ? "$prod_table.product_desc" : "''";

$q = "SELECT $cat_table.category_id, $manuf_table.mf_name, $prod_table.product_sku, $prod_table.product_id, $prod_table.product_name, $prod_table.product_desc, $prod_table.product_full_image, $price_table.product_price, $price_table.product_currency, $prod_table.product_weight, $tax_rate_table.tax_rate, $discount_table.amount, $discount_table.is_percent, $discount_table.start_date, $discount_table.end_date
FROM $prod_table
LEFT JOIN $prod_cat_xref_table ON $prod_table.product_id = $prod_cat_xref_table.product_id
LEFT JOIN $cat_table ON $prod_cat_xref_table.category_id = $cat_table.category_id
LEFT JOIN $manuf_xref_table ON $prod_table.product_id = $manuf_xref_table.product_id
LEFT JOIN $manuf_table ON $manuf_xref_table.manufacturer_id = $manuf_table.manufacturer_id
LEFT JOIN $price_table ON $prod_table.product_id = $price_table.product_id
LEFT JOIN $tax_rate_table ON $prod_table.product_tax_id = $tax_rate_table.tax_rate_id
LEFT JOIN $discount_table ON $prod_table.product_discount_id = $discount_table.discount_id
WHERE $prod_table.product_publish = 'Y' AND $prod_table.product_parent_id = 0
GROUP BY $prod_table.product_id
ORDER BY $cat_table.category_id DESC";
$r = @mysql_query($q);

###################################################################


##### Print product data ####################################################

// There are no errors so we can continue
if (!mysql_error()) {
		
	while (list($cat_id, $prod_manufacturer, $prod_model, $prod_id, $prod_name, $prod_desc, $prod_image, $prod_price, $prod_currency, $product_weight, $tax_rate, $discount_amount, $discount_is_percent, $discount_start_date, $discount_end_date) = mysql_fetch_row($r)) {		
		
		// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
		if ($already_sent[$prod_id] == 1) continue;
		
		// Clean description
		$prod_desc = smfeed_clean_description($prod_desc);
		
		// Get price
		if ($tax_rate != NULL) {
			if ($apply_taxes == "on") {
				$prod_price *= ($tax_rate + 1);
			}
		}
		elseif ($rate > 0) {
			// if we didn't find a product tax rate id, let's use the store's tax rate
			if ($apply_storetaxes == "on") {
				$prod_price *= ($rate + 1);
			}
		}	
		$prod_price = round( $prod_price, 2 );
		
		// Apply product discount
		$now_date_time = mktime(date("G"),date("i"),date("s"),date("n"),date("j"),date("Y"));
		if ($apply_discount == "on" && $discount_amount > 0 && (($discount_start_date < $now_date_time || $discount_start_date == 0) && ($now_date_time < $discount_end_date || $discount_end_date == 0))) {
			if ($discount_is_percent > 0) {
				$prod_price -= ($prod_price * $discount_amount) / 100;
			}
			else {
				$prod_price -= $discount_amount;
			}
		}
		$prod_price = round( $prod_price, 2 );
		
		// Clean product name (new lines)
		$prod_name = str_replace("\n", "", strip_tags($prod_name));
		$prod_name = str_replace("\r", "", strip_tags($prod_name));
		$prod_name = str_replace("\t", " ", strip_tags($prod_name));
		
		// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
		$prod_desc = smfeed_replace_not_in_tags("\n", "<BR />", $prod_desc);
		$prod_desc = str_replace("\n", " ", $prod_desc);
		$prod_desc = str_replace("\r", "", $prod_desc);
		$prod_desc = str_replace("\t", " ", $prod_desc);
		
		// Get category name
		$category_name = smfeed_get_full_cat($cat_id, $CAT_ARR);		
		
		$category_flypage = ($CAT_ARR[$cat_id]['category_flypage'] != "") ? $CAT_ARR[$cat_id]['category_flypage'] : "shop.flypage";
		$prod_url = smfeed_get_product_url($prod_id, $cat_id, $category_flypage);
		
		// Add GA Tagging parameters to url
		if ($add_tagging == "on") {
			$and_param = (preg_match("/\?/", $prod_url)) ? "&" : "?";
			$prod_url = $prod_url . $and_param . $tagging_params;
		}
		
		$prod_image = ($prod_image != "") ? smfeed_get_product_image($prod_image) : "";
		
		// Add VAT to prices
		if ($add_vat == "on") {
			$prod_price = $prod_price * $vat_value;
		}
		
		// Clean product names and descriptions (separators)
		if ($datafeed_separator == "\t") {
			$category_name = str_replace("\t", " ", $category_name);
			// Continue... tabs were already removed
		}
		elseif ($datafeed_separator == "|") {
			$prod_name = str_replace("|", " ", strip_tags($prod_name));
			$prod_desc = str_replace("|", " ", $prod_desc);
			$category_name = str_replace("|", " ", $category_name);
		}
		else {
			print "Incorrect columns separator.";
			exit;		
		}
		
		// Output the datafeed content
		// Category, Manufacturer, Model, ProdCode, ProdName, ProdDescription, ProdURL, ImageURL, Price, Currency
		print
			$category_name . $datafeed_separator .
			$prod_manufacturer . $datafeed_separator .
			$prod_model . $datafeed_separator .
			$prod_id . $datafeed_separator .
			$prod_name . $datafeed_separator .
			$prod_desc . $datafeed_separator .
			$prod_url . $datafeed_separator .
			$prod_image . $datafeed_separator .
			$prod_price . $datafeed_separator .
			$prod_currency . "\n";
		
		$already_sent[$prod_id] = 1;
	}
}
else {
	print "Query error: " . mysql_error();
}

###################################################################


##### Functions ########################################################

// Function to return the Product URL based on your product ID
function smfeed_get_product_url($prod_id, $cat_id, $flypage){
	global $mosConfig_live_site;	
	return $mosConfig_live_site . "/index.php?page=shop.product_details&flypage=" . $flypage . "&product_id=" . $prod_id . "&category_id=" . $cat_id . "&option=com_phpshop";
}

// Function to return the Product Image based on your product image or optionally Product ID
function smfeed_get_product_image($prod_image){
	global $mosConfig_live_site;
	
	if ($prod_image == "") {
		return false;
	}
	else {
		return $mosConfig_live_site . "/components/com_phpshop/shop_image/product/" . $prod_image;
	}
}

// Function to get category with full path
function smfeed_get_full_cat($cat_id, $CATEGORY_ARR) {

	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['category_name'];
	
	while (sizeof($CATEGORY_ARR[$item_arr['parent_id']]) > 0 && is_array($CATEGORY_ARR[$item_arr['parent_id']]) ) {
		
		$cat_name = $CATEGORY_ARR[$item_arr['parent_id']]['category_name'] . " > " . $cat_name;
		$item_arr = $CATEGORY_ARR[$item_arr['parent_id']];
	}
	
	// Strip html from category name
	$cat_name = smfeed_html_to_text($cat_name);
	
	return $cat_name;
}

function smfeed_html_to_text($string){

	$search = array (
		"'<script[^>]*?>.*?</script>'si",  // Strip out javascript
		"'<[\/\!]*?[^<>]*?>'si",  // Strip out html tags
		"'([\r\n])[\s]+'",  // Strip out white space
		"'&(quot|#34);'i",  // Replace html entities
		"'&(amp|#38);'i",
		"'&(lt|#60);'i",
		"'&(gt|#62);'i",
		"'&(nbsp|#160);'i",
		"'&(iexcl|#161);'i",
		"'&(cent|#162);'i",
		"'&(pound|#163);'i",
		"'&(copy|#169);'i",
		"'&(reg|#174);'i",
		"'&#8482;'i",
		"'&#149;'i",
		"'&#151;'i"
		);  // evaluate as php
	
	$replace = array (
		" ",
		" ",
		"\\1",
		"\"",
		"&",
		"<",
		">",
		" ",
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&copy;",
		"&reg;",
		"<sup><small>TM</small></sup>",
		"&bull;",
		"-",
		);
	
	$text = preg_replace ($search, $replace, $string);
	return $text;
	
}

function smfeed_clean_description($string){

	$search = array (
		"'<html>'i",
		"'</html>'i",
		"'<body>'i",
		"'</body>'i",
		"'<head>.*?</head>'si",
		"'<!DOCTYPE[^>]*?>'si"
		); 
		
	$replace = array (
		"",
		"",
		"",
		"",
		"",
		""
		); 
		
	$text = preg_replace ($search, $replace, $string);
	return $text;

}

function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

exit;

?>